/* $Id: hex.c,v 1.1 1996/11/07 08:03:40 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	16iϊ , String ֐
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#include <string.h>	/* strcpy */

#include "estruct.h"
#include "hex.h"


char Hex[16] = "0123456789abcdef";
int Zerosupress_mode = 0;


/* 蔲 ^^; */
extern char *itod2( char *buf , ULONG num )
{
    int i;

    i = num % 100;

    if( i/10 )
	*buf++ = i/10 + '0';
    *buf++ = num % 10 + '0';

    *buf = '\0';
    return buf;
}



extern char *itox( char *buf , ULONG num , int width )
{
    if( option_Z ) {
	int  i;
	char buffer[9];

	if( num != 0 ) {
	    buffer[8] = '\0';
	    for( i = 7 ; i >= 0 && num != 0 ; i-- ) {
		buffer[ i ] = Hex[ num & 0xf ];
		num >>= 4;
	    }
	    strcpy( buf , buffer + i + 1 );
	    return buf + 7 - i;
	} else {
	    *buf++ = '0';
	    *buf   = '\0';
	    return buf;
	}
    }

    {
	int  i;
	char *bufp;

	bufp = buf = buf + width;
	*bufp = '\0';
	for( i = width - 1 ; i >= 0 ; i-- ) {
	    *--bufp = Hex[ num & 0xf ];
	    num >>= 4;
	}
    return buf;
    }
}


extern char *itox8_without_0supress( char *buf , ULONG num )
{
    int i;
    char *bufp;

    bufp = buf = buf + 8;
    *bufp = '\0';
    for( i = 7 ; i >= 0 ; i-- ) {
	*--bufp = Hex[ num & 0xf ];
	num >>= 4;
    }
    return buf;
}


extern char *itox6_without_0supress( char *buf , ULONG num )
{
    int i;
    char *bufp;

    bufp = buf = buf + 6;
    *bufp = '\0';
    for( i = 5 ; i >= 0 ; i-- ) {
	*--bufp = Hex[ num & 0xf ];
	num >>= 4;
    }
    return buf;
}


extern char *itox4_without_0supress( char *buf , ULONG num )
{
    int i;
    char *bufp;

    bufp = buf = buf + 4;
    *bufp = '\0';
    for( i = 3 ; i >= 0 ; i-- ) {
	*--bufp = Hex[ num & 0xf ];
	num >>= 4;
    }
    return buf;
}


/**** ȉ̊֐GNU C CompilergpɂinlineWJ܂. ****/

#ifndef __GNUC__

extern char *strend( char *ptr )
{
    while( *ptr++ )
	;
    return --ptr;
}


extern char *itox2( char *buf , ULONG num )
{
    if( !option_Z || num >= 0x10 ) {
	*buf++ = Hex[ ( num >> 4 ) & 0xf ];
	*buf++ = Hex[ num & 0xf ];
	*buf = '\0';
	return buf;
    }
    *buf++ = Hex[ num & 0xf ];
    *buf = '\0';
    return buf;
}


extern char *itox2_without_0supress( char *buf , ULONG num )
{
    *buf++ = Hex[ ( num >> 4 ) & 0xf ];
    *buf++ = Hex[ num & 0xf ];
    *buf = '\0';
    return buf;
}


extern char *itoxd( char *buf , ULONG num , int width )
{
    if( Zerosupress_mode != 1 || num >= 10 )
	*buf++ = '$';
    return( width == 2 ? itox2( buf , num ) : itox( buf , num , width ) );
}


extern char *itox6( char *buf , ULONG num )
{
    return itox( buf , num , ( num >= 0x1000000 ? 8 : 6 ) );
}


extern char *itox6d( char *buf , ULONG num )
{
    if( Zerosupress_mode != 1 || num >= 10 )
	*buf++ = '$';
    return itox6( buf , num );
}

#endif	/* __GNUC__ */

/* EOF */
