/* $Id: symbol.h,v 1.1 1996/10/24 04:27:50 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	V{l[ǗW[wb_
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#ifndef	SYMBOL_H
#define	SYMBOL_H


struct _symlist {
    struct _symlist *next;
    char *sym;
};

typedef struct _symlist symlist;

typedef struct {
    address adrs;
    UWORD   type;
    symlist *next;
    char *sym;
} symbol;

typedef struct {
    address adrs;
    char    *sym;
} const_symbol;


extern void	init_symtable( void );
extern void	make_symtable( void );
extern void	free_symbuf( void );
extern symbol	*symbol_search( address );
extern void	add_constsymbol( address , char* );
extern void	add_symbol( address , int , char* );
#if 0
extern void	del_symbol( address );
#endif
extern boolean	is_exist_symbol( void );
extern int	get_constsymbol_num( void );
extern const_symbol *get_constsymbol( int );


#endif	/* SYMBOL_H */

/* EOF */
